HDU 5389 Zero Escape(DP + 滚动数组)

Zero EscapeTime Limit: 2000/1000 MS (Java/Others)Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 864Accepted Submission(s): 438

Problem Description

Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.This is the definition of digital root on Wikipedia:The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.For example, the digital root of, because.In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered, the digital root of their identifier sum must be.For example, playerscan get into the door, but playerscan’t.There is two doors, numbered. Maybe, but they are two different door.And there isplayers, everyone must get into one of these two doors. Some players will get into the door, and others will get into the door.For example:players areThere is only one way to distribute the players: all players get into the door. Because there is no player to get into the door, the digital root limit of this door will be ignored.Given the identifier of every player, please calculate how many kinds of methods are there,.

Input

The first line of the input contains a single number, the number of test cases.For each test case, the first line contains three integers.Next line contains, describing the identifier of every player.

Output

For each test case, output a single integer in a single line, the number of ways that theseplayers can get into these two doors.

Sample Input

43 9 11 2 63 9 12 3 35 2 31 1 1 1 19 9 91 2 3 4 5 6 7 8 9

Sample Output

101060

Author

SXYZ

Source

题意:给出n个人的id,有两个门,,每个门有一个标号,我们记作a和b,现在我们要将n个人分成两组,进入两个门中,使得两部分人的标号的和(迭代的求,直至变成一位数)分别等于a和b,问有多少种分法,(可以所有的人进入一个门)。

点击打开链接

pt = j – p[i];

状态转移方程: dp[i][j] = dp[i-1][j] + dp[i-1][pt];

两种处理方法:

#include<iostream>#include<algorithm>#include<stdio.h>#include<string.h>#include<stdlib.h>using namespace std;const int N = 100001;const int mod = 258280327;int dp[N][10];int n,a,b;int p[N];int num(int xx,int yy){int t = xx + yy;if(t%9 == 0){return 9;}return t%9;}int pnum(int xx,int yy){int tt = xx – yy;if(tt%9 == 0){return 9;}if(tt%9<0){return 9+(tt%9);}return tt%9;}int main(){int T;scanf("%d",&T);while(T–){int sum = 0;scanf("%d%d%d",&n,&a,&b);for(int i=1;i<=n;i++){scanf("%d",&p[i]);sum = num(sum,p[i]);}memset(dp,0,sizeof(dp));dp[0][0] = 1;for(int i=1;i<=n;i++){for(int j=0;j<=9;j++){dp[i][j] += dp[i-1][j];dp[i][j] = dp[i][j]%mod;int pt = pnum(j,p[i]);if(pt == 9){dp[i][j] += max(dp[i-1][0],dp[i-1][9]);}else{dp[i][j] += dp[i-1][pnum(j,p[i])];}dp[i][j] = dp[i][j]%mod;}}int ans = 0;if(num(a,b) == sum){ans = dp[n][a];if(a == sum){ans–;}}if(a == sum){ans++;}if(b == sum){ans++;}printf("%d\n",ans);}return 0;}

仿佛一支飘荡在水上的华丽咏叹调。

HDU 5389 Zero Escape(DP + 滚动数组)

相关文章:

你感兴趣的文章:

标签云: